﻿using Xamarin.Forms;
using Syncfusion.SfSchedule.XForms;
using System.Collections.ObjectModel;
using System;

namespace SfSchedule_Appointment_XForms
{
    public partial class SfSchedule_Appointment_XFormsPage : ContentPage
    {
        ObservableCollection<ScheduleAppointment> scheduleAppointmentCollection = new ObservableCollection<ScheduleAppointment>();
        public SfSchedule_Appointment_XFormsPage()
        {
            InitializeComponent();
            schedule.ScheduleView = ScheduleView.WeekView;

			//Adding schedule appointment in schedule appointment collection 
			var scheduleAppointment = new ScheduleAppointment()
			{
				StartTime = new DateTime(2017, 09, 01, 10, 0, 0),
				EndTime = new DateTime(2017, 09, 01, 12, 0, 0),
				Subject = "Occurs every alternate day",
				IsRecursive = true
			};

			//Adding schedule appointment in schedule appointment collection
			scheduleAppointmentCollection.Add(scheduleAppointment);

			//Adding schedule appointment collection to DataSource of SfSchedule
			schedule.DataSource = scheduleAppointmentCollection;

			// Creating recurrence rule
			RecurrenceProperties recurrenceProperties = new RecurrenceProperties();
			recurrenceProperties.RecurrenceType = RecurrenceType.Daily;
			recurrenceProperties.IsRangeRecurrenceCount = true;
			recurrenceProperties.DailyNDays = 2;
			recurrenceProperties.IsDailyEveryNDays = true;
			recurrenceProperties.IsWeeklySunday = false;
			recurrenceProperties.IsWeeklyMonday = true;
			recurrenceProperties.IsWeeklyTuesday = false;
			recurrenceProperties.IsWeeklyWednesday = false;
			recurrenceProperties.IsWeeklyThursday = false;
			recurrenceProperties.IsWeeklyFriday = false;
			recurrenceProperties.IsWeeklySaturday = false;
			recurrenceProperties.RangeRecurrenceCount = 10;
			recurrenceProperties.RecurrenceRule = DependencyService.Get<IRecurrenceBuilder>().RRuleGenerator(recurrenceProperties, scheduleAppointment.StartTime, scheduleAppointment.EndTime);

			// Setting recurrence rule to schedule appointment
			scheduleAppointment.RecurrenceRule = recurrenceProperties.RecurrenceRule;


            update_Button.Clicked+= Update_Button_Clicked;
        }

        private void Update_Button_Clicked(object sender, EventArgs e)
        {

			RecurrenceProperties recurrenceProperties = new RecurrenceProperties();
			recurrenceProperties.RecurrenceType = RecurrenceType.Daily;
			recurrenceProperties.IsRangeRecurrenceCount = true;
			recurrenceProperties.DailyNDays = 2;
			recurrenceProperties.IsDailyEveryNDays = true;
			recurrenceProperties.IsWeeklySunday = false;
			recurrenceProperties.IsWeeklyMonday = true;
			recurrenceProperties.IsWeeklyTuesday = false;
			recurrenceProperties.IsWeeklyWednesday = false;
			recurrenceProperties.IsWeeklyThursday = false;
			recurrenceProperties.IsWeeklyFriday = false;
			recurrenceProperties.IsWeeklySaturday = false;
			recurrenceProperties.RangeRecurrenceCount = 40; // HERE IS THE NEW VALUE
			recurrenceProperties.RecurrenceRule = DependencyService.Get<IRecurrenceBuilder>().RRuleGenerator(recurrenceProperties, (schedule.DataSource as ObservableCollection<ScheduleAppointment>)[0].StartTime, (schedule.DataSource as ObservableCollection<ScheduleAppointment>)[0].EndTime);

            (schedule.DataSource as ObservableCollection<ScheduleAppointment>)[0].RecurrenceRule = recurrenceProperties.RecurrenceRule;
            (schedule.DataSource as ObservableCollection<ScheduleAppointment>)[0].Subject = "I Expect the change";
        }
    }
}
